%global momorel 19

Summary:        Kernel and Hardware related utilities
Name:           kernel-utils
Version:        2.4
Release:	%{momorel}m
Group:          System Environment/Base
License:        GPL
Url:            http://www.urbanmyth.org/microcode/
Source0:        microcode_ctl-1.09.tar.gz
Source1:	microcode_ctl.init
Source10:	dmidecode-2.2.tar.gz
Source20: 	smartmontools-5.33.tar.gz
Source30:	smartd.initd
Source40:	rng-tools-1.1.tar.gz
Source50:	x86info-1.12b.tgz
Source60:	longrun-0.9.tar.bz2
Source90:	irqbalance-0.09.tar.gz
Source91:	irqbalance.init
Source92:	irqbalance.sysconfig
Source100:	hardlink.c
Source110:      http://carlthompson.net/dl/cpuspeed/cpuspeed-1.1.tar.gz
Source111:      cpuspeed.init
Source120:      readahead.c
Source121:      readahead.init
Source122:      readahead.files
Source123:      readahead_early.init
Source124:      readahead.early.files
Buildroot:      %{_tmppath}/%{name}-%{version}-root
Prereq:		initscripts chkconfig
Requires:	fileutils
BuildPreReq: 	readline-devel ncurses-devel automake autoconf
%ifarch {ix86}
Obsoletes:	microcode_ctl
%endif
Patch1: microcode_ctl.patch
Patch2: smartmontools-smartd.patch
Patch3: cpuspeed.patch
#Patch4: irqbalance-pie.patch
Patch5: longrun-0.9-14.patch
#Patch6: microcde_ctl-no-include-asm-processor.patch
Patch7: cpuspeed-smp.patch

%description
kernel-utils contains several utilities that can be used to control
the kernel or your machines hardware. Included are
* dmidecode - gives information about the bios and motherboard revisisons
* microcode_ctl - updates the microcode on Intel cpu's
* smartctl - monitor the health of your disks

%prep
%setup -q -c -a 0 -a 10 -a 20 -a 40 -a 50 -a 60 -a 90 -a 110

%patch1
#%%patch2 -p0 -b .momonga
%patch3 -p0
#%%patch4 -p1
%patch5 -p0
#%%patch6 -p0
%patch7 -p0

%build
rm -rf %{buildroot}

mkdir -p %{buildroot}/usr/sbin
mkdir -p %{buildroot}/usr/man
mkdir -p %{buildroot}%{_initscriptdir}
mkdir -p %{buildroot}/etc/sysconfig

%ifarch %{ix86} x86_64
cd microcode_ctl-1.09
make CFLAGS="%{optflags}"
cd ..
%endif

cd dmidecode-2.2
make
cd ..

cd rng-tools-1.1
%configure
make
cd ..

cd cpuspeed-1.1
make CFLAGS="$RPM_OPT_FLAGS -fpie -pie -Wl,-z,relro,-z,now"
cd ..

%install
mkdir -p %{buildroot}/usr/share/man/man{1,8}


%ifarch %{ix86} x86_64
cd microcode_ctl-1.09

make DESTDIR=%{buildroot} PREFIX=%{_prefix} \
     INSDIR=/sbin MANDIR=%{_mandir}/man8 RCDIR=/etc MICDIR=/etc/firmware install clean

install %{SOURCE1} %{buildroot}%{_initscriptdir}/microcode_ctl
%endif

%ifarch %{ix86}
cd ../x86info-1.12b
make
install x86info %{buildroot}%{_sbindir}/x86info
install x86info.1 %{buildroot}%{_mandir}/man1/

cd ../longrun
make
install longrun %{buildroot}%{_sbindir}
install longrun.1 %{buildroot}%{_mandir}/man1
%endif

%ifnarch ppc
cd ../cpuspeed-1.1
%else
cd cpuspeed-1.1
%endif
install cpuspeed %{buildroot}/usr/sbin
install %{SOURCE111} %{buildroot}%{_initscriptdir}/cpuspeed
install cpuspeed.conf %{buildroot}/etc/cpuspeed.conf
cd ..

cd smartmontools-5.33
%configure
make DESTDIR=%{buildroot} smartd smartctl install
install %{SOURCE30} %{buildroot}%{_initscriptdir}/smartd

cd ../irqbalance
make
install irqbalance  %{buildroot}%{_sbindir}
install %{SOURCE91} %{buildroot}%{_initscriptdir}/irqbalance
install %{SOURCE92} %{buildroot}/etc/sysconfig/irqbalance

cd ../rng-tools-1.1
make DESTDIR=%{buildroot} install

gcc -Wall -O2 -g %{SOURCE100} -o %{buildroot}/usr/sbin/hardlink
gcc -Wall -O2 -g %{SOURCE120} -o %{buildroot}/usr/sbin/readahead
install %{SOURCE121} %{buildroot}%{_initscriptdir}/readahead
install %{SOURCE122} %{buildroot}/etc/readahead.files
install %{SOURCE123} %{buildroot}%{_initscriptdir}/readahead_early
install %{SOURCE124} %{buildroot}/etc/readahead.early.files

%ifarch %{ix86} x86_64 ia64
cd ../dmidecode-2.2
install dmidecode %{buildroot}%{_sbindir}
%endif 

chmod -R a-s %{buildroot}
rm -rf %{buildroot}/etc/rc.d

%clean
[ "%{buildroot}" != "/" ] && [ -d %{buildroot} ] && rm -rf %{buildroot};

%files
%defattr(-,root,root)
%ifarch %{ix86} x86_64
%{_initscriptdir}/microcode_ctl
/etc/firmware/*
/sbin/microcode_ctl
%endif
%ifarch %{ix86}
%{_sbindir}/x86info
%{_sbindir}/longrun
%endif
%{_sbindir}/cpuspeed
%{_initscriptdir}/cpuspeed
%attr(0644,root,root) %config /etc/cpuspeed.conf
%attr(0644,root,root) /etc/readahead.files
%attr(0644,root,root) /etc/readahead.early.files
%{_sbindir}/irqbalance
%{_sbindir}/hardlink
/usr/sbin/readahead
%attr(0644,root,root) %{_mandir}/*/*
%{_sbindir}/smartd
%{_sbindir}/smartctl
%{_initscriptdir}/smartd
%{_initscriptdir}/irqbalance
%{_initscriptdir}/readahead
%{_initscriptdir}/readahead_early
%attr(0644,root,root) /etc/sysconfig/irqbalance
%doc /usr/share/doc/smartmontools-5.33
%config /etc/smartd.conf
%{_bindir}/rngtest
%{_sbindir}/rngd
%ifarch %{ix86} ia64 x86_64
%{_sbindir}/dmidecode
%endif

%preun
if [ "$1" = "0" ] ; then
 /sbin/service smartd stop
%ifarch %{ix86} x86_64
 /sbin/chkconfig --del irqbalance
 /sbin/chkconfig --del microcode_ctl
%endif
 /sbin/chkconfig --del cpuspeed 
 /sbin/chkconfig --del smartd
fi

%post
/sbin/chkconfig --add smartd
/sbin/chkconfig --add readahead
/sbin/chkconfig --add readahead_early
/sbin/chkconfig --add cpuspeed
%ifarch %{ix86}
/sbin/chkconfig --add irqbalance
%endif
%ifarch %{ix86} x86_64
/sbin/chkconfig --add microcode_ctl
%endif

%changelog
* Wed Apr 20 2005 Masahiro Takahata <takahata@momonga-linux.org>
- (2.4-19m)
- fix readahead.early.files readahead.files for Momonga Linux 2

* Wed Jan 26 2005 mutecat <mutecat@momonga-linux.org>
- (2.4-18m)
- arrange ppc

* Fri Jan 22 2005 YONEKAWA Susumu <yonekawa@mmg.roka.jp>
- (2.4-17m)
- revised for smartd.conf

* Tue Jan 18 2005 Toru Hoshina <t@momonga-linux.org>
- (2.4-16m)
- x86_64 enabled.
- update microcode_ctl-1.09
- update microcode_ctl.patch
- update smartmontools-5.33
- update smartmontools-smartd.patch
- own smartd.init.
- add cpuspeed-smp.patch

* Thu Dec 16 2004 TABUCHI Takaaki <tab@momonga-linux.org>
- (2.4-15m)
- add Patch6: microcde_ctl-no-include-asm-processor.patch

* Sat Jul 31 2004 Masahiro Takahata <takahata@momonga-linux.org>
- (2.4-14m)
- update readahead.files

* Sat Jul 31 2004 Masahiro Takahata <takahata@momonga-linux.org>
- (2.4-13m)
- update readahead.early.files

* Mon Jul 26 2004 Masahiro Takahata <takahata@momonga-linux.org>
- (2.4-12m)
- import from rawhide

* Sun Jul 25 2004 Masahiro Takahata <takahata@momonga-linux.org>
- (2.4-11m)
- update smartmontools-5.32
- update microcode_ctl-1.07
- update microcode_ctl.patch

* Tue May  4 2004 Toru Hoshina <t@momonga-linux.org>
- (2.4-10m)
- import from FC1.

* Mon Oct 20 2003 Arjan van de Ven <arjanv@redhat.com> 2.4.8-39
- update smartmontools to version 5.21

* Thu Oct 16 2003 Arjan van de Ven <arjanv@redhat.com> 2.4.8-38
- add /usr/bin/hardlink

* Mon Sep 08 2003 Arjan van de Ven <arjanv@redhat.com> 2.4.8-36
- update smartmontools to a 64 bit clean version
- update irqbalance

* Thu Aug 21 2003 Arjan van de Ven <arjanv@redhat.com> 2.4.8-35
- update dmidecode

* Tue Jul 29 2003 Arjan van de Ven <arjanv@redhat.com> 2.4-8.33
- disable smartd by default

* Thu Jul 03 2003 Arjan van de Ven <arjanv@redhat.com>
- clean up the spec a bit
- drop cpqarray monitor; too many dependencies for the use it gets

* Mon Jun 02 2003 Arjan van de Ven <arjanv@redhat.com>
- switch to smartmontools for SMART monitoring

* Fri May 02 2003 Arjan van de Ven <arjanv@redhat.com>
- add chstk for setting non-exec stack flags

* Wed Jan 22 2003 Michael K. Johnson <johnsonm@redhat.com> 2.4-8.28
- /etc/sysconfig/irqbalance to set --oneshot from config file

* Sun Jan 19 2003 Arjan van de Ven <arjanv@redhat.com> 2.4-8.26
- updated irqbalance code

* Sat Jan 18 2003 Arjan van de Ven <arjanv@redhat.com> 2.4-8.23
- add initial irqbalance code

* Thu Jan 16 2003 Bill Nottingham <notting@redhat.com> 2.4-8.22
- fix %%post/%%preun on non-x86

* Tue Jan  7 2003 Nalin Dahyabhai <nalin@redhat.com> 2.4-8.21
- Rebuild

* Fri Dec 13 2002 Elliot Lee <sopwith@redhat.com> 2.4-8.20
- Build on all archs

* Thu Dec 12 2002 Michael K. Johnson <johnsonm@redhat.com> 2.4-8.19
- added report-acpi-bug script

* Tue Dec 03 2002 Arjan van de Ven <arjanv@redhat.com> 2.4-8.18
- update x86info to version 1.11
- include pmtools for acpi disasm

* Fri Nov 15 2002 Michael K. Johnson <johnsonm@redhat.com> 2.4-8.17
- HP hasn't said it is shipping hammer, so no need for cpqarrayd on hammer
- uml is x86-only for now -- should probably move to its own package
- deal with new net-snmp additional #include requirements

* Thu Nov 14 2002 Michael K. Johnson <johnsonm@redhat.com> 2.4-8.15
- Added acpidmp for x86 only for now (has x86-specific bits in it)
- Updated package cruft removal

* Thu Sep 12 2002 Guy Streeter <streeter@redhat.com> 2.4-8.14
- No eepro100-diag for ppc.

* Fri Aug 23 2002 Elliot Lee <sopwith@redhat.com> 2.4-8.13
- Don't cop out of building uml_net on ia64 - instead, remove usage of
  (effect-free) SA_NOCLDWAIT if not defined.
- Include all the uml tools (+ jailtest/uml_moo/uml_switch/uml_watchdog)

* Fri Aug 23 2002 Arjan van de Ven <arjanv@redhat.com> 2.4-8.12
- add uml tools

* Wed Aug 21 2002 Elliot Lee <sopwith@redhat.com> 2.4-8.11
- Remove ExclusiveArch: i386 (since it builds everywhere)
- Include smartd/smartctl man pages

* Wed Jul 31 2002 Arjan van de Ven <arjanv@redhat.com>
- added longrun uitility

* Thu Jun 27 2002 Elliot Lee <sopwith@redhat.com> 2.4-8.7
- Patch31 for net-snmp 

* Fri Jun 21 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Thu Jun 20 2002 Michael K. Johnson <johnsonm@redhat.com>
- include the man pages

* Sat Mar 30 2002	Arjan van de Ven <arjanv@redhat.com>
- change initorder to not shut services down after NFS has shut down
  to allow /usr to be NFS mounted

* Wed Mar 20 2002	Arjan van de Ven <arjanv@redhat.com>
- fix microcode_ctl to work on smp

* Thu Mar 14 2002 Bill Nottingham <notting@redhat.com> 2.4-5
- don't run things by default

* Wed Feb  6 2002 Tim Powers <timp@redhat.com> 2.4-3.6.2
- fix %%post sciptlet typo

* Mon Feb 04 2002	Arjan van de Ven <arjanv@redhat.com>
- fail gracefully in microcode_ctl if firmware isn't downloaded

* Mon Jan 28 2002	Arjan van de Ven <arjanv@redhat.com>
- added x86info

* Tue Jan 15 2002       Bill Nottingham <notting@redhat.com>
- move eepro100-diag from kudzu to here

* Fri Jan 11 2002	Arjan van de Ven <arjanv@redhat.com>
- added cpqarrayd for monitoring cpqarray drives too
  from http://starbreeze.knoware.nl/~hugo/compaq/

* Mon Jan 07 2002	Arjan van de Ven <arjanv@redhat.com>
- added smartsuite for monitoring disk health status

* Fri Dec 07 2001	Arjan van de Ven <arjanv@redhat.com>
- Initial packaging
